﻿namespace TabsStudioSorter
{
    class RuleMatch
    {
        public static string ExtractM(string input, SortingRule rule)
        {
            if (input == null || rule.match == null || rule.match.Length == 0)
                return null;

            System.Text.RegularExpressions.Regex reg = new System.Text.RegularExpressions.Regex(rule.match);
            System.Text.RegularExpressions.Group m = reg.Match(input).Groups["M"];

            if (!m.Success)
                return null;

            return m.Value;
        }

        public static string GetTabNameForSorting(System.Windows.Controls.TabItem tabItem, bool withPath)
        {
            string tabName = GetTabName(tabItem);
            if (withPath)
                return tabName;

            int pathEnd = tabName.LastIndexOf('/');
            return pathEnd >= 0 ? tabName.Substring(pathEnd + 1) : tabName;
        }

        public static string GetTabNameUntransformed(TabsStudioExt.Tab tab)
        {
            if (tab.TitleManager.UntransformedSplitTitle != null && tab.TitleManager.UntransformedSplitTitle.Length > 0)
                return tab.TitleManager.UntransformedSplitTitle;

            return tab.TitleManager.UntransformedTitle;
        }

        private static string GetTabName(System.Windows.Controls.TabItem tabItem)
        {
            System.Windows.Controls.DockPanel tabInternals = tabItem.Header as System.Windows.Controls.DockPanel;
            System.Windows.Controls.StackPanel tabNameGroup = tabInternals.Children[0] as System.Windows.Controls.StackPanel;
            System.Windows.Controls.Label tabName = tabNameGroup.Children[0] as System.Windows.Controls.Label;
            return tabName.Content as string;
        }
    }
}
