﻿namespace TabsStudioSorter
{
    public class ListItem
    {
        public ListItem(SortingRule rule)
        {
            Name = rule.name;
            Type = rule.type.ToString();
            Match = rule.match;
            Order = rule.inverseOrder.ToString();
            SuperGroup = rule.superGroup.ToString();
        }

        public string Name { get; set; }
        public string Type { get; set; }
        public string Match { get; set; }
        public string Order { get; set; }
        public string SuperGroup { get; set; }
    }

    class SortingRulesList : System.Windows.Controls.ListView
    {
        public SortingRulesList()
        {
            gridView = new System.Windows.Controls.GridView();
            AddColumn(gridView.Columns, "Rule name", "Name");
            AddColumn(gridView.Columns, "Rule type", "Type");
            AddColumn(gridView.Columns, "Match regex", "Match");
            AddColumn(gridView.Columns, "Inverse order", "Order");
            AddColumn(gridView.Columns, "Super group", "SuperGroup");

            SelectionMode = System.Windows.Controls.SelectionMode.Single;
            View = gridView;
        }

        public void UpdateRules(System.Collections.Generic.List<SortingRule> rules)
        {
            Items.Clear();
            foreach (SortingRule rule in rules)
                Items.Add(new ListItem(rule));
        }

        private void AddColumn(System.Windows.Controls.GridViewColumnCollection columns, string name, string bindingName)
        {
            System.Windows.Controls.GridViewColumn col = new System.Windows.Controls.GridViewColumn();
            col.Header = name;
            col.DisplayMemberBinding = new System.Windows.Data.Binding(bindingName);
            columns.Add(col);
        }

        private System.Windows.Controls.GridView gridView;
    }
}
